// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of scatter
//
// scatter is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// scatter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the
//       Free Software Foundation, Inc.
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#ifndef ESALINPOWSYMDB_H
#define ESALINPOWSYMDB_H

#include <string>
#include <vector>

#include <Exception/Exception.h>

#include "ScatterDB.h"

namespace Scatter {

    class EsaLinPowSymDB : public ScatterDB {

    public:
	EsaLinPowSymDB( const std::string& filename ) throw ( Exception );
	~EsaLinPowSymDB( void ) { };

	bool lookUpScatterAngle( double energy, double sin_alpha, double rannum, double& theta );

	static bool db_matches( const std::string& filename );

	bool is_symmetric() { return true; }

    private:

	double lookUpTheta( const long idx, double rannum );

	ColData _esa;
	ColData _p0;
	ColData _ptop;
	ColData _pdelta;
	ColData _powtop;
	ColData _normtop;

	Column2D _pdist;
    };

}

#endif // ! ESALINPOWSYMDB_H
